#!/usr/local/bin/perl
use Socket;

( $my_port) = @ARGV;
$my_port = 2222 unless $my_port;
$protocol = ( getprotobyname( 'tcp'))[2];
$my_socket_addr = pack( 'S n a4 x8', AF_INET, $my_port, "\0\0\0\0");
socket( MYSOCKET, AF_INET, SOCK_STREAM, $protocol) || die "Socket error : $!";
print STDOUT "- Socket succeeded \n";

bind( MYSOCKET, $my_socket_addr) || die "Bind error : $!";
print STDOUT "- Bind succeeded \n";

listen( MYSOCKET, 5) || die "Listen error : $!";
print STDOUT "- Listening at port $my_port \n";

select( MYSOCKET);
$| = 1;
while (1) {

	$ce_socket_addr = accept( NEWSOCKET, MYSOCKET);
	die "Accept error : $!" unless ( $ce_socket_addr);
	( $dummy, $ce_port, $ce_addr, $dummy) = unpack( 'S n a4 x8', $ce_socket_addr);
	$ce_ip = join( ".", unpack( 'C4', $ce_addr));
	print STDOUT "\n*** Accept connection [$ce_ip] with $ce_port ***\n\n";
	
	select( NEWSOCKET);
	$| = 1;
	$pid = fork;
	if ( $pid == 0) {
	   while ( <NEWSOCKET>) {
	     print STDOUT "Client>$_";
	     print NEWSOCKET $_;
	   }
	   close( NEWSOCKET);
	   exit;
	}
	
	close( NEWSOCKET);
	
}