#!/usr/local/bin/perl
use Socket;

( $sv_port) = @ARGV;
$sv_port = 2222 unless $sv_port;
@sv_ip = ( 203, 154, 19, 120);
$protocol = ( getprotobyname( 'tcp'))[2];
$sv_addr = pack( 'C4', @sv_ip);
$my_socket_addr = pack( 'S n a4 x8', AF_INET, 0, "\0\0\0\0");
$sv_socket_addr = pack( 'S n a4 x8', AF_INET, $sv_port, $sv_addr);
$sv_ip = join( "." ,unpack( 'C4', $sv_addr));

socket( MYSOCKET, AF_INET, SOCK_STREAM, $protocol) || die "Socket error : $!\n";
print STDOUT "- Socket succeeded \n";

bind( MYSOCKET, $my_socket_addr) || die "Bind error : $!\n";
print STDOUT "- Bind succeeded \n";

connect( MYSOCKET, $sv_socket_addr) || die "Connect error : $!\n";
print STDOUT "- Connect to IP [$sv_ip] port $sv_port succeeded \n";

$my_socket_addr = getsockname( MYSOCKET);
( $dummy, $my_port, $my_addr, $dummy) = unpack( 'S n a4 x8', $my_socket_addr);
$my_ip = join( ".", unpack( 'C4', $my_addr));
print STDOUT " Client use IP [$my_ip] port $my_port \n\n";

select( MYSOCKET);
$| = 1;
select( STDOUT);
$| = 1;
$pid = fork;

if ( $pid == 0) {
   while ( <MYSOCKET>) {
      print STDOUT "Server>$_";
   }
} else {
   while ( <STDIN>) {
      print MYSOCKET $_;
   }
}

close( MYSOCKET);