#!/usr/local/bin/perl
use Socket;

( $my_port) = @ARGV;
$my_port = 2222 unless $my_port;
$protocol = ( getprotobyname( 'tcp'))[2];
$my_socket_addr = pack( 'S n a4 x8', AF_INET, $my_port, "\0\0\0\0");

socket( MYSOCKET, AF_INET, SOCK_STREAM, $protocol) || die "Socket error : $!";
print STDOUT "- Socket succeeded \n";

bind( MYSOCKET, $my_socket_addr) || die "Bind error : $!";
print STDOUT "- Bind succeeded \n";

listen( MYSOCKET, 5) || die "Listen error : $!";
print STDOUT "- Listening at port $my_port \n";

select( MYSOCKET);
$| = 1;

while (1) {
	print STDOUT "- Waiting for connection ...\n";
	$remoteConnect = accept( NEWSOCK, MYSOCKET);
	die "Accept error : $!" unless ( $remoteConnect);
	$remoteAddr = ( unpack( 'S n a4 x8', $remoteConnect))[2];
	$remoteIP = join( ".", unpack( 'C4', $remoteAddr));
	$remoteHost = ( gethostbyaddr( $remoteAddr, AF_INET))[0];
	
	$pid = fork;
	if ( $pid == 0) {
	   $lineGET = <NEWSOCK>;
	   chop $lineGET;
	   ( $method, $pathFile, $httpVersion) = split( / /, $lineGET);
	   print STDOUT "From IP [$remoteIP] Host [$remoteHost] ";
	   print STDOUT "$method $pathFile $httpVersion\n";
	   if ( open( FILE, ".$pathFile")) {
	      print NEWSOCK "HTTP/1.0 200\n";
	      if ( $pathFile =~ /.gif/) {
	         print NEWSOCK "Content-type: image/gif\n\n";
	      } elsif ( $pathFile =~ /.jpg/) {
	         print NEWSOCK "Content-type: image/jpeg\n\n";
	      } else {
	         print NEWSOCK "Content-type: text/html\n\n";
	      }
	      @lines = <FILE>;
	      print NEWSOCK @lines;
	      close(FILE);
	   } else {
	      print NEWSOCK "HTTP/1.0 404 File not found!\n";
	      print NEWSOCK "Content-type: text/html\n\n";
	      print NEWSOCK "<HTML><HEAD><TITLE>Error</TITLE>
	      </HEAD><BODY><H1>Error</H1>";
	      print NEWSOCK "Error : $! [$pathFile]";
	      print NEWSOCK "</BODY></HTML>";
	   }
	   close( NEWSOCK);
	   exit;
	}
	close( NEWSOCK);
}