#!/usr/local/bin/perl
use IO::Socket;

($my_port) = @ARGV;
$my_port = 2222 unless $my_port;
$mysocket = IO::Socket::INET->new( 	Proto => 'tcp', 
																		LocalPort => $my_port, 
																		Timeout => 5, 
																		Listen => 5) || die "Socket Error $!";
print STDOUT "- Listening at port $my_port \n";

$newsocket = $mysocket->accept;
if (!( $newsocket)) {
   print "5 seconds passed without no connection
   from anyone...\n";
   exit;
}

$newsocket->autoflush( 1);
$ce_host = $newsocket->peerhost;
$ce_port = $newsocket->peerport;
print STDOUT "- Accept connection from [$ce_ip] port $ce_port \n\n";

while ( <$newsocket>) {
   print STDOUT "Client-> $_";
}

$newsocket->close;
$mysocket->close;