#!/usr/local/bin/perl
use IO::Socket;

( $my_port) = @ARGV;
$my_port = 2222 unless $my_port;
$mysocket = IO::Socket::INET->new( 	Proto => 'tcp', 
																		LocalPort => $my_port, 
																		Reuse => 1,
																		Listen => 5) || die "Socket Error $!";
print STDOUT "- Listening at port $my_port \n";

while (1) {
	print STDOUT "- Waiting for connection ...\n";
	$newsocket = $mysocket->accept;
	die "Accept error : $!" unless ( $newsocket);

	$newsocket->autoflush( 1);
	$remoteIP = $newsocket->peerhost;

	$pid = fork;
	if ( $pid == 0) {
	   $lineGET = <$newsocket>;
	   chop $lineGET;
	   ( $method, $pathFile, $httpVersion) = split( / /, $lineGET);
	   print STDOUT "From IP [$remoteIP] $method
	   $pathFile $httpVersion\n";
	   if ( open( FILE, ".$pathFile")) {
	      $newsocket->send( "HTTP/1.0 200\n");
	      if ( $pathFile =~ /.gif/) {
	         $newsocket->send( "Content-type: image/gif\n\n");
	      } elsif ( $pathFile =~ /.jpg/) {
	         $newsocket->send( "Content-type: image/jpeg\n\n");
	      } else {
	         $newsocket->send( "Content-type: text/html\n\n");
	      }
				
	      while ( <FILE>) { 
				   $newsocket->send( $_); 
				}
	      close(FILE);
	   } else {
	      $newsocket->send( "HTTP/1.0 404 File not found!\n");
	      $newsocket->send( "Content-type: text/html\n\n");
	      $newsocket->send( "<HTML><HEAD><TITLE>Error</TITLE></HEAD>");
	      $newsocket->send( "<BODY><H1>Error</H1>");
	      $newsocket->send( "Error : $! [$pathFile]");
	      $newsocket->send( "</BODY></HTML>");
	   }

	   $newsocket->close;
	   exit;
	}
	
	$newsocket->close;
	
}