#!/usr/local/bin/perl
use IO::Socket;

$fullDir = "/home/zorkia/cgi-bin/message";
&getDateTime;
print "******************************\n";
print "Working at $sysDateTime \n";
$fileMessage = "$dw-$hour-$min";
if ( ! ( open( MSGFILE, "$fullDir/$fileMessage"))) {
   print "- No file $fileMessage \n";
   exit;
}

$countSend = 0;
$countError = 0;
&lockForRead( MSGFILE);

while ( <MSGFILE>) {
   ( $service, $number, $password, $message) = split( /\t/, $_);
   print $service;
   if ( $service eq "152") {
      $server = "www.phonelink.net";
      $uri = "/cgi-bin/psnpd.pl";
      $referer = "http://www.phonelink.net/index.html";
      $msgSend = "Phone=$number&Mesg=$message&Day=Now&Hour =Now&Minute=Now&encode=spg.net";
   } elsif ( $service eq "162") {
      $server = "www.hutchison.co.th";
      $uri = "/html/cyberpage/cybermsg.asp";
      $referer = "http://www.hutchison.co.th/html/cyberpage/cybermsg.asp";
      $msgSend = "pager_no=$number&accesspw=$password&subject=$message&from=.&SendBtn=Send Message";
   } elsif ( $service eq "1144") {
      $server = "www.paclink.co.th";
      $uri = "/phtml/send.phtml";
      $referer = "http:///phtml/send.phtml";
      $msgSend = "pager_number=$number&message=$message&flag=send flag ja";
   } elsif ( $service eq "1500") {
      $server = "203.146.1.214";
      $uri = "/cgi-bin/web2pager.cgi";
      $referer = "http://www.easycall.lenso.co.th/english/webpager.html";
      $msgSend = "namefrom=xcom-pager&subject=$number&message=$message";
   } elsif ( $service eq "GSM") {
      $server = "www.ais900.com";
      $uri = "/cgi-gsmweb/web2gsm.cgi";
      $referer = "http://www.ais900.com/gsmweb";
      $msgSend = "szGsmNo=$number&szGsmPwd=$password&szMesg=$message";
   } else {
      next;
   }

   $msgSend =~ s/ /%20/g;
   $lenMsg = length( $msgSend);
   $mysocket = IO::Socket::INET->new( 	PeerAddr=> $server, 
	 																			PeerPort => 'http(80)');
   if ( ! ( $mysocket)) {
      $countError++;
      next;
   }

   $mysocket->autoflush( 1);
   print $mysocket "POST $uri HTTP/1.0\n";
   print $mysocket "Accept: */*\n";
   print $mysocket "Referer: $referer\n";
   print $mysocket "Content-type:
   application/x-www-form-urlencoded\n";
   print $mysocket "Content-length: $lenMsg\n";
   print $mysocket "\n";
   print $mysocket "$msgSend";
   
	 @data_return = <$mysocket>;
   close $mysocket;
   $countSend++;
	 
}

print "- Sent $countSend messages\n";
print "- Error $countError messages\n";
&unLock( MSGFILE);
close( MSGFILE);

open( MSGFILE, ">$fullDir/$fileMessage");
close( MSGFILE);

sub lockForRead {
local( $file) = @_;
   flock( $file, 2);
}

sub unLock {
local( $file) = @_;
   flock( $file, 8);
}

sub getDateTime {
( $ssec, $smin, $shour, $smday, $smon,
   $syear, $swday, $syday, $sisdst) = localtime();
   $sec = sprintf( "%02d", $ssec);
   $min = sprintf( "%02d", $smin);
   $hour = sprintf( "%02d", $shour);
   $date = sprintf( "%02d", $smday);
   $mon = sprintf( "%02d", $smon + 1);
   $dw = $swday;
   $year = $syear + 1900;
   $sysDateTime = "$date-$mon-$year
   $hour:$min:$sec";
}